#include "module_traverser.h"

std::vector<SgClassDefinition*> risc::traverser::find_all_modules()
{
  Rose_STL_Container<SgNode*> class_defintions =
    NodeQuery::querySubTree (get_project(),V_SgClassDefinition);

  std::vector<SgClassDefinition*> modules;

  for (Rose_STL_Container<SgNode*>::iterator iter = class_defintions.begin();
      iter != class_defintions.end(); iter++) {

    SgClassDefinition *cd = isSgClassDefinition(*iter);

    //Is the definition located in the SystemC library include path?
    //If yes we don't need this definition

    bool sysc_lib_definition = false;

    // We compare the path of the node with the path of the given library path
    for(SgStringList::iterator
        iter  = get_project()->get_includeDirectorySpecifierList().begin();
        iter != get_project()->get_includeDirectorySpecifierList().end();
        iter++){

      if(cd->get_file_info()->get_filenameString().find((*iter).substr(2))
          != std::string::npos) {

        sysc_lib_definition  = true;
      }
    }

    // In this case it is a SystemC library node
    if(sysc_lib_definition)
      continue;

    //first we have to check if the class is derived from sc_module
    if(risc::tools::is_derived_from_sc_module(cd)) {

      // second, we have to check if the module is not a 'built-in' systemc
      // module
      if(!is_defined_in_included_library(get_project(), cd)) {
        modules.push_back(cd);
      }
    }
  }

  return modules;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
