#ifndef PRIMITIVE_CHANNEL_H_INCLUDED_
#define PRIMITIVE_CHANNEL_H_INCLUDED_

#include <vector>

#include "channel.h"
#include "rose.h"

namespace risc {

class PrimitiveChannel: public Channel {

public:

  /**
   * \brief Default constructor
   */
  explicit PrimitiveChannel(SgClassDefinition *ast_node);

private:

  /**
   * \brief Disabled copy constructor
   */
  PrimitiveChannel(const PrimitiveChannel& pcd);
};

typedef std::vector<PrimitiveChannel*> PrimitiveChannelVector;
typedef std::vector<PrimitiveChannel*>::iterator PrimitiveChannelVectorIter;
typedef std::vector<PrimitiveChannel*>::const_iterator PrimitiveChannelVectorConstIter;

} // end namespace risc

#endif /* PRIMITIVE_CHANNEL_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
